/*
Copyright 2020 Replicated Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/replicatedhq/kurl/kurlkinds/pkg/apis/cluster/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeInstallers implements InstallerInterface
type FakeInstallers struct {
	Fake *FakeClusterV1beta1
	ns   string
}

var installersResource = schema.GroupVersionResource{Group: "cluster.kurl.sh", Version: "v1beta1", Resource: "installers"}

var installersKind = schema.GroupVersionKind{Group: "cluster.kurl.sh", Version: "v1beta1", Kind: "Installer"}

// Get takes name of the installer, and returns the corresponding installer object, and an error if there is any.
func (c *FakeInstallers) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.Installer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(installersResource, c.ns, name), &v1beta1.Installer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Installer), err
}

// List takes label and field selectors, and returns the list of Installers that match those selectors.
func (c *FakeInstallers) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.InstallerList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(installersResource, installersKind, c.ns, opts), &v1beta1.InstallerList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.InstallerList{ListMeta: obj.(*v1beta1.InstallerList).ListMeta}
	for _, item := range obj.(*v1beta1.InstallerList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested installers.
func (c *FakeInstallers) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(installersResource, c.ns, opts))

}

// Create takes the representation of a installer and creates it.  Returns the server's representation of the installer, and an error, if there is any.
func (c *FakeInstallers) Create(ctx context.Context, installer *v1beta1.Installer, opts v1.CreateOptions) (result *v1beta1.Installer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(installersResource, c.ns, installer), &v1beta1.Installer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Installer), err
}

// Update takes the representation of a installer and updates it. Returns the server's representation of the installer, and an error, if there is any.
func (c *FakeInstallers) Update(ctx context.Context, installer *v1beta1.Installer, opts v1.UpdateOptions) (result *v1beta1.Installer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(installersResource, c.ns, installer), &v1beta1.Installer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Installer), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeInstallers) UpdateStatus(ctx context.Context, installer *v1beta1.Installer, opts v1.UpdateOptions) (*v1beta1.Installer, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(installersResource, "status", c.ns, installer), &v1beta1.Installer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Installer), err
}

// Delete takes name of the installer and deletes it. Returns an error if one occurs.
func (c *FakeInstallers) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(installersResource, c.ns, name), &v1beta1.Installer{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeInstallers) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(installersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.InstallerList{})
	return err
}

// Patch applies the patch and returns the patched installer.
func (c *FakeInstallers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Installer, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(installersResource, c.ns, name, pt, data, subresources...), &v1beta1.Installer{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Installer), err
}
